#include <STC8H.H>
#include "stc8h8k64u_iic.h"

void I2C_Init()
{
	P_SW2 |= 0x80;
  P_SW2 |= 0x10;              //I2CѡP2.4,P2.5
  P2M0 = 0xff; P2M1 = 0x00; 
  I2CCFG = 0xc0|63;              //ʹI2Cģʽ
  I2CMSST = 0x00;
}

void I2C_Wait()
{
    while (!(I2CMSST & 0x40));
    I2CMSST &= ~0x40;
}

void I2C_Start()
{
    I2CMSCR = 0x01;                         //START
    I2C_Wait();
}

void I2C_SendData(unsigned char dat)
{
    I2CTXD = dat;                           //дݵݻ
    I2CMSCR = 0x02;                         //SEND
    I2C_Wait();
}

void I2C_RecvACK()
{
    I2CMSCR = 0x03;                         //ͶACK
    I2C_Wait();
}

unsigned char I2C_RecvData()
{
    I2CMSCR = 0x04;                         //RECV
    I2C_Wait();
    return I2CRXD;
}

void I2C_SendACK()
{
    I2CMSST = 0x00;                         //ACKź
    I2CMSCR = 0x05;                         //ACK
    I2C_Wait();
}

void I2C_SendNAK()
{
    I2CMSST = 0x01;                         //NAKź
    I2CMSCR = 0x05;                         //ACK
    I2C_Wait();
}

void I2C_Stop()
{
    I2CMSCR = 0x06;                         //STOP
    I2C_Wait();
}

void I2C_Writebyte(unsigned char SLA,unsigned char addr,unsigned char dat)
{
    I2C_Start();                                //ʼ
    I2C_SendData(SLA);                         //豸ַ+д
    I2C_RecvACK();
    I2C_SendData(addr);                         //ʹ洢ַ
    I2C_RecvACK();
    I2C_SendData(dat);
    I2C_RecvACK();
    I2C_Stop();  
}

unsigned char I2C_Readbyte(unsigned char SLA,unsigned char addr)
{
		unsigned char dat;
	  I2C_Start();           
    I2C_SendData(SLA);
    I2C_RecvACK();
    I2C_SendData(addr);
    I2C_RecvACK();
    I2C_Start();
    I2C_SendData(SLA|0x01);
    I2C_RecvACK();
    dat = I2C_RecvData();
		I2C_SendACK();
    I2C_SendNAK();
    I2C_Stop();   
		return dat;
}


void I2C_WriteNbyte(unsigned char SLA,unsigned char addr, unsigned char *p, unsigned char number)
{
    I2C_Start();
    I2C_SendData(SLA);
    I2C_RecvACK();
    I2C_SendData(addr);
    I2C_RecvACK();
    do
    {
        I2C_SendData(*p++);
        I2C_RecvACK();
    }
    while(--number);
    I2C_Stop();
}

void I2C_ReadNbyte(unsigned char SLA,unsigned char addr, unsigned char *p, unsigned char number)
{
    I2C_Start();
    I2C_SendData(SLA);
    I2C_RecvACK();
    I2C_SendData(addr);
    I2C_RecvACK();
    I2C_Start();
    I2C_SendData(SLA|0x01);
    I2C_RecvACK();
    do
    {
        *p = I2C_RecvData();
        p++;
        if(number != 1) I2C_SendACK();
    }
    while(--number);
    I2C_SendNAK();
    I2C_Stop();
}
